#!/usr/bin/perl
#
###### Thumbnail Gallery Submission Wizard Install ####
###### Build 007

BEGIN {
print "Content-type: text/html\n\n";

$version = $];
if ($version < 5.000) { print "TGSW requires Perl5 or better. Perl version on this system is $version\n"; exit; }
}

BEGIN {
use CGI::Carp qw(fatalsToBrowser);
}

use Cwd;
$dir = cwd;

### Windows users uncomment and edit the next line ###
#$dir="C:/home/path/to/cgi-bin/tgsw";
#########

$directory = $0;
$directory =~ s#/[^/]*$##;
unshift(@INC, $directory);

#$ed="PRO";
$fe="cgi";
$rd = length($0); $rd--;
$last_byte = substr($0, $rd, 1); $rd--;
$last_byte .= substr($0, $rd, 1);
if ($last_byte eq "lp") { $fe="pl"; }

if ($ENV{'QUERY_STRING'})
	{
	$mana = $ENV{'QUERY_STRING'};
	$mana =~ tr/+/ /;
	$mana =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	}

unless ($dir =~ "/")
	{
	$result = eval 'require ("setup.pl")';
	if (-e $path_cgi) { $dir=$path_cgi; }
	elsif (($directory =~ "/") && ($directory !~ ".cgi")) { $dir=$directory; }
	elsif ($mana) { $dir=$mana; }
	}

if ($dir) { $setup="$dir"."/setup.pl"; }
if ($ENV{"REQUEST_METHOD"} eq 'POST')
	{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	$formdata=$buffer;
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
	        ($name, $value) = split(/=/, $pair);
	        $value =~ tr/+/ /;
	        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	        $data{$name} = $value;
	}
	}

&htt_top;
# Decide what to do

if ($data{'action'} eq "step1") { &step1; }
elsif ($data{'action'} eq "step2") { &step2; }
elsif ($data{'action'} eq "step3") { &step3; }
elsif ($data{'action'} eq "step4") { &step4; }
elsif ($data{'action'} eq "step5") { &step5; }
elsif ($data{'action'} eq "step6") { &step6; }
elsif ($data{'action'} eq "step7") { &step7; }
elsif ($data{'action'} eq "step8") { &step8; }
elsif ($data{'action'} eq "step9") { &step9; }
elsif ($data{'action'} eq "stepa") { &stepa; }
elsif ($data{'action'} eq "red") { &red; }
elsif ($data{'action'} eq "config") { &config; }
elsif ($data{'action'} eq "configup") { &configup; }
else { &none; }

print "\n</body></html>\n";

sub none {

if (-e $setup)
	{
	print "<p>\n<table align=\"center\" border=\"8\"><tr><td>\n";
	print "<b>Configure Options</b>";
	print "<BR><FONT SIZE=-1>advanced options configuration.</FONT>\n";
	print "<BR><FONT SIZE=-1>(experienced users only)</FONT></td>\n";
	print "<td><br><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"config\"><input type=submit value=\"SUBMIT\"></form></td></tr>\n";
	print "<tr><td><form method=\"POST\"><b>Configuration Wizard</b>";
	print "<BR><FONT SIZE=-1>easy configuration.</FONT>\n";
	print "<BR><FONT SIZE=-1>(recommended for all users)</FONT></td>\n";
	print "<td><br><input type=\"hidden\" name=\"action\" value=\"stepa\"><input type=submit value=\"SUBMIT\"></form></td></tr>\n";
	print "</td></tr></table>\n";
	if ($ed)
		{
		print "<p><center><a href=\"http://www.worldadult.com/tgsw/re/remotescripts/\">Learn how to use a free host with TGSW</a></center>\n";
		}
	$result = eval 'require ("setup.pl")';
	unless ($result)
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "<center><b>W A R N I N G</b></center>\n";
		print "<p>Setup has been run on this system but your setup files contains a fatal error.\n";
		print "<br>Suggest you start setup again.\n<p><center>Server Response:</center>$!\n";
		print "</td></tr></table>\n";
		}
	else
		{
		unless ($libinstall) { &compat; }
		}
	}
else { &stepa; }

}

sub compat {

open (DATA, "$setup");
@files = <DATA>;
close DATA;
$newsetup="";
foreach $line (@files)
	{
	if (($line =~ "lib qw") && ($line !~ "#")) { @namea = split(/\(/, $line); $libin=$namea[1]; }
	if ($libin)
		{
		@namea = split(/\)/, $libin);
		$libin=$namea[0];
		$newsetup .= "\$libinstall=\"$libin\"\;\n";
		undef($libin);
		}
	$newsetup .= $line;
	}
unless ($libinstall) { return; }
if (open (DATA, ">$setup"))
	{
	print "<p>\n<table align=\"center\" border=\"0\" BGCOLOR=\"#CCCCCC\"><tr><td>\n";
	print "Updated setup configuration\n";
	print "</td></tr></table>\n";
	print DATA $newsetup;
	close DATA;
	chmod(0666, $setup);
	}
else
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "unable to write $setup\n";
	print "<br>You probably need to change file permissions on this file to 666\n";
	print "<p>\nServer said <b>$!</b>\n";
	print "</td></tr></table>\n";
	}

}

sub stepa {

if (($^O =~ "in32") || ($^O eq "dos"))
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "<center><b>This looks to be a Microsoft Windows machine.</b></center>\n";
	print "<center><b>Make sure you do the following before continuing:</b></center>\n";
	print "<p>Open each .cgi file with a text editor such as notepad or wordpad except email.cgi and webstart.cgi.\n";
	print "<br>Near top of each file you will see lines for Window users to modify.\n";
	print "<br>You will need to uncomment the line by removing the # character from the start of the line.\n";
	print "<p>Example, in admin.cgi you will see this: \n";
	print "<br>### Windows users uncomment and edit the next line ### \n";
	print "<br>#BEGIN { chdir('C:/home/path/to/cgi-bin/tgsw'); } \n";
	print "<br>######### \n";
	print "<p>You would want to modify that to something like : \n";
	print "<br>### Windows users uncomment and edit the next line ### \n";
	print "<br>BEGIN { chdir('C:/websites/mysite/cgi-bin/tgsw'); } \n";
	print "<br>#########\n";
	print "<p><hr>\n<p><center><b>ALSO ... </b></center>\n";
	print "<br><center>When entering directory paths in this script use a foward slash, not a back slash.\n";
	print "<center>Correct: C:/websites/mysite/cgi-bin/</center>\n";
	print "<center>Not correct: C:\\websites\\mysite\\cgi-bin\\</center>\n";
	print "</td></tr></table>\n";
	}
unless ($dir)
	{
	print "<p>\n<center><form method=\"POST\">Enter full path to TGSW installation directory.</center>\n";
	print "<center><input type=\"hidden\" name=\"action\" value=\"red\"><input type=\"text\" size=\"40\" name=\"path\"></center>\n";
	print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
	exit;
	}
print "<p>\n<center><form method=\"POST\">What name do you want to use on TGP submission forms that ask for a name ?</center>\n";
print "<center><input type=\"hidden\" name=\"action\" value=\"step1\"><input type=\"text\" size=\"40\" name=\"name\"></center>\n";
print "<p>\n<center>What email address do you want to use on TGP submission forms that ask for an email address ?</center>\n";
print "<center><input type=\"text\" size=\"40\" name=\"email\"></center>";
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
print "<center><b>W A R N I N G</b></center>\n";
print "<p>During this installation do not press your browser\'s back button.\n";
print "<br>If you make a mistake return to this page and start over.\n<p>\n";
if (-e $setup) { print "Any custom options you currently have configured will not be saved.\n<p>\n"; }
print "</td></tr></table>\n";
if ($ed)
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#CCCCCC\"><tr><td>\n";
	print "<center><b>N O T E</b></center>\n";
	print "<p>This installation program will <b>NOT</b> configure your script to use a free host.\n";
	print "<br>Complete this installation as if you will not be using a free host.\n";
	print "<br>After installation is complete select <b>Options Configuration</b> to configure a free host if desired.\n<p>\n";
	print "</td></tr></table>\n";
	}

}

sub step1 {

@email = split(/@/, $data{email});
unless (open (DATA, ">$setup"))
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "unable to write $dir\n";
	print "<br>You probably need to change file permissions on above directory to 777\n";
	print "<p>\nServer said <b>$!</b>\n";
	print "</td></tr></table>\n";
	exit;
	}
print DATA "# Thumbnail Gallery Submission Wizard $ed config file\n\n";
print DATA "\$your_name=\"$data{name}\"\;\n";
print DATA "\$your_email=\"$email[0]\\";
print DATA "\@$email[1]\"\;\n";
close DATA;
chmod(0666, $setup);

if (($^O =~ "in32") || ($^O eq "dos"))
	{
	print "<p>\n<center>Enter the server you use to send outgoing email from $data{email} (SMTP server)</center>\n";
	print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step2\"><input type=\"text\" size=\"40\" name=\"mail_server\"></center>\n";
	}
else
	{
	print "<p>\n<center>Where is sendmail located on this system ?</center>\n";
	print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step2\"><input type=\"text\" size=\"40\" name=\"sendmail\"";
	if (-e "/usr/lib/sendmail") { print "value =\"/usr/lib/sendmail\"></center>\n"; }
	elsif (-e "/usr/sbin/sendmail") { print " value =\"/usr/sbin/sendmail\"></center>\n"; }
	elsif (-e "/usr/bin/sendmail") { print " value =\"/usr/bin/sendmail\"></center>\n"; }
	else { print "></center>\n"; }
	print "<center>If a value is already present in the box above it is probably correct, just click next</center>\n";
	}
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
}

sub step2 {

unless ($restep)
	{
	unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
	if (($^O =~ "in32") || ($^O eq "dos"))
		{
		print DATA "\$mailprog=\"./SendMail.pm\"\;\n";
		print DATA "\$mail_server=\"$data{mail_server}\"\;\n";
		}
	else
		{
		print DATA "\$mailprog=\"$data{sendmail}\"\;\n";
		}
	close DATA;
	chmod(0666, $setup);
	}

print "<p>\n<center>Enter full path to TGSW installation directory</center>\n";
print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step3\"><input type=\"text\" size=\"50\" name=\"path_cgi\" value =\"$dir\"></center>\n";
print "<center>If a value is already present in the box above it is probably correct, just click next</center>\n";
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";

}

sub step3 {

unless ($restep)
	{
	$rd = length($data{path_cgi}); $rd--;
	$last_byte = substr($data{path_cgi}, $rd, 1);
	$first_byte = substr($data{path_cgi}, 0, 1);
	if ($last_byte eq "/") { chop($data{path_cgi}); }
	unless (-e "$data{path_cgi}")
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "unable to open $data{path_cgi}\n";
		print "<p>\nServer said <b>$!</b>\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step2;
		exit;
		}
	unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
	print DATA "\$path_cgi=\"$data{path_cgi}\"\;\n";
	close DATA;
	chmod(0666, $setup);
	}


print "<p>\n<center><FONT SIZE=+1><B>Where are your images located that will be used to build galleries ?</B></FONT></center>\n";
print "<p>\n<center>Base directory is full path to your image sub directory(ies).</center>\n";
print "<center>sub directories are names of directories which contain your full size images.</center>\n";
print "<p>\n<center><b>EXAMPLE #1</b></center>\n";
print "<table align=\"center\" border=\"0\" BGCOLOR=\"#CCCCCC\"><tr><td>You plan to use a single directory of images located at\n";
print "<br>/usr/home/website/htdocs/images/\n";
print "<br>you would enter <b>/usr/home/website/htdocs/</b> as the base directory.\n";
print "<br>and enter <b>images</b> as sub directory #1, the rest should be left blank.\n";
print "</td></tr></table>";

print "<p>\n<center><b>EXAMPLE #2</b></center>\n";
print "<table align=\"center\" border=\"0\" BGCOLOR=\"#CCCCCC\"><tr><td>You plan to use three image directories located at\n";
print "<br>/usr/home/website/htdocs/blonde/\n";
print "<br>/usr/home/website/htdocs/teen/\n";
print "<br>/usr/home/website/htdocs/fetish/\n";
print "<br>you would enter <b>/usr/home/website/htdocs/</b> as the base directory,\n";
print "<br>enter <b>blonde</b> as sub directory #1,\n";
print "<br>enter <b>teen</b> as sub directory #2,\n";
print "<br>enter <b>fetish</b> as sub directory #3, the rest should be left blank.\n";
print "</td></tr></table>";

print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step4\">Base directory : <input type=\"text\" size=\"50\" name=\"source_dir\"></center>\n";
print "<table align=\"center\" cellspacing=\"0\" border=\"0\">\n";
$a=1;
while ($a){
print "<tr><td>Image sub directory #$a </td><td><input type=\"text\" size=\"30\" name=\"source_dir$a\"></td></tr>\n";
$a++;
if (21<=$a) { last; }
}
print "</table>\n<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
print "<center><b>W A R N I N G</b></center>\n";
print "<p>Changing your list of image directories after configuration is a bad idea. \n";
print "List all image directories now that you may want to use in the future, \n";
print "even if the directories are empty with no images. \n";
print " You can add images to those empty directories at any time.\n<p>\n";
print "</td></tr></table>\n";

}

sub step4 {

unless ($restep)
	{
	unless (-e "$data{source_dir}")
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "unable to open $data{source_dir}\n";
		print "<br>Server said <b>$!</b>\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step3;
		exit;
		}
	}

$rd = length($data{source_dir}); $rd--;
$last_byte = substr($data{source_dir}, $rd, 1);
$first_byte = substr($data{source_dir}, 0, 1);
if ($last_byte ne "/") { $data{source_dir} .= "/"; }
$a=1;
while ($a){
$temp="source_dir$a";
if ($data{$temp})
	{
	$rty=1;
	if ($data{$temp} =~ /\W/)
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "Image directory names must contain letters, digits, and underscores only.\n";
		print "<br>No blank spaces or other special characters.\n";
		print "<p>Rejected directory name: <b>$data{$temp}</b>\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step3;
		exit;
		}
	if ($data{$temp} =~ "/")
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "$data{$temp} should not include a forward slash\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step3;
		exit;
		}
	$tes="$data{source_dir}$data{$temp}";
	unless (-e $tes)
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "Unable to open directory $tes\n";
		print "<p>Server said <b>$!</b>\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step3;
		exit;
		}
	}
$a++;
if (21<=$a) { last; }
unless ($rty)
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "no image directories specified.\n";
	print "<br>You must list a minimum of 1 image directory.\n";
	print "</td></tr></table>\n";
	$restep=1;
	&step3;
	exit;
	}
}
unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
unless ($restep)
	{
	print DATA "\$source_dir=\"$data{source_dir}\"\;\n";
	print DATA "\@subd=(";
	}
print "<p>\n<center><form method=\"POST\">What is the directory name that contains thumbnail images ?</center>\n";
print "<p>\n<center>This directory must exist in each of the following directories :</center>\n";
print "<input type=\"hidden\" name=\"source_dir\" value=\"$data{source_dir}\">\n";
$a=1;
while ($a){
$temp="source_dir$a";
if ($data{$temp})
	{
	$tes="$data{source_dir}$data{$temp}";
	unless (-e $tes) { &error("$tes does not exist"); }
	print "<input type=\"hidden\" name=\"$temp\" value=\"$data{$temp}\">\n";
	}

if (($data{$temp}) && ($more))
	{
	unless ($restep)
		{
		print DATA ",";
		}
	$more=1;
	}

if ($data{$temp})
	{
	unless ($restep)
		{
		print DATA "\'$data{$temp}\'";
		}
	$more=1;
	print "<center>$data{source_dir}$data{$temp}/</center>";
	}
$a++;
if (21<=$a) { last; }
}

unless ($restep)
	{
	print DATA ")\;\n";
	}

close DATA;
chmod(0666, $setup);

print "<center><input type=\"hidden\" name=\"action\" value=\"step5\"><input type=\"text\" name=\"thumb\" value =\"thumb\"></center>\n";
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";

}

sub step5 {

if ($data{thumb} =~ "/")
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "Do not include a forward slash in thumbnail directory name\n";
	print "</td></tr></table>\n";
	$restep=1;
	&step4;
	exit;
	}

unless ($restep)
	{
	$a=1;
	while ($a){
	$temp="source_dir$a";
	if ($data{$temp})
		{
		$tes="$data{source_dir}$data{$temp}/$data{thumb}";
		unless (-e $tes)
			{
			print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
			print "Unable to open directory $tes\n";
			print "<p>Server said <b>$!</b>\n";
			print "</td></tr></table>\n";
			$restep=1;
			&step4;
			exit;
			}
		}
	$a++;
	if (21<=$a) { last; }
	}

	unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
	print DATA "\$thumb=\"$data{thumb}/\"\;\n";
	close DATA;
	chmod(0666, $setup);
	}

print "<p>\n<center>What directory do you want the thumbnail galleries stored in ?</center>\n";
print "<center>Enter full path</center>\n";
print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step6\"><input type=\"text\" size=\"60\" name=\"dest_dir\"></center>\n";
print "<input type=\"hidden\" name=\"thumb\" value=\"$data{thumb}\">";
print "<p>\n<center>How do you access the above directory from a web browser ?</center>\n";
print "<center>Enter full url begining with http://</center>\n";
print "<center><input type=\"text\" size=\"60\" name=\"base_url\" value=\"http://\"></center>\n";
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";

}

sub step6 {

$rd = length($data{dest_dir}); $rd--;
$last_byte = substr($data{dest_dir}, $rd, 1);
$first_byte = substr($data{dest_dir}, 0, 1);
if ($last_byte eq "/") { chop($data{dest_dir}); }

$rd = length($data{base_url}); $rd--;
$last_byte = substr($data{base_url}, $rd, 1);
$first_byte = substr($data{base_url}, 0, 1);
if ($last_byte ne "/") { $data{base_url} .= "/"; }

unless (-e "$data{dest_dir}")
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "Unable to open directory $data{dest_dir}\n";
	print "<p>Server said <b>$!</b>\n";
	print "</td></tr></table>\n";
	$restep=1;
	&step5;
	exit;
	}
$test="$data{dest_dir}/TGSW.TEST";
unless (open (TEST, ">$test"))
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "Can not write to directory $data{dest_dir}\n";
	print "<br>Please change permissions on this directory to 777\n";
	print "<p>Server said <b>$!</b>\n";
	print "</td></tr></table>\n";
	$restep=1;
	&step5;
	exit;
	}
close TEST;
chmod(0666, $test);
$test="$data{dest_dir}/$data{thumb}";
unless (opendir (TEST, "$test"))
	{
	unless (mkdir($test,00700))
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "Can not create sub directory $data{thumb} in directory $data{dest_dir}\n";
		print "<br>Please create and/or change permissions on this directory to 777\n";
		print "<p>Server said <b>$!</b>\n";
		print "</td></tr></table>\n";
		$restep=1;
		&step5;
		exit;
		}
	}
close TEST;
chmod(0777, $test);
$test="$data{dest_dir}/$data{thumb}/TGSW.TEST";
unless (open (TEST, ">$test"))
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "Can not write to directory $data{dest_dir}/$data{thumb}\n";
	print "<br>Please change permissions on this directory to 777\n";
	print "<p>Server said <b>$!</b>\n";
	print "</td></tr></table>\n";
	$restep=1;
	&step5;
	exit;
	}
close TEST;
chmod(0666, $test);

unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
print DATA "\$dest_dir=\"$data{dest_dir}\"\;\n";
print DATA "\$base_url=\"$data{base_url}\"\;\n";
close DATA;
chmod(0666, $setup);

print "<p>\n<center>How many thumbnails do you want to display on each gallery ?</center>\n";
print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step7\"><input type=\"text\" name=\"num_to_show\"></center>\n";
print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";

}

sub step7 {

unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
print DATA "\$num_to_show=$data{num_to_show}\;\n";
print DATA "\$log_sub=1\;\n";
print DATA "\$copy_images=1\;\n";
print DATA "\$test_only=1\;\n";
if ($ed)
	{
	print DATA "#\$login_name=\"na\"\;\n";
	print DATA "#\$password=\"na\"\;\n";
	print DATA "#\$ftp_host=\"ftp.na.com\"\;\n";
	print DATA "#\$ftp_dir=\"/na/\"\;\n";
	print DATA "#\$remote_web_script=\"remote.cgi\"\;\n";
	}
close DATA;
chmod(0666, $setup);

$result = eval 'require LWP';
unless ($result) { print ("<LI>LWP.pm not found.</LI>\n"); $norp = 1; $libwww=1; }
$result = eval 'require LWP::UserAgent';
unless ($result) { print ("<LI>LWP/UserAgent not found.</LI>\n"); $norp = 1; $libwww=1; }
$result = eval 'require HTTP::Headers';
unless ($result) { print ("<LI>HTTP/Headers not found.</LI>\n"); $norp = 1; $libwww=1; }

if ($libwww)
	{
	print "<p>\n<center>Could not find perl libwww modules.</center>\n";
	print "<center>If libwww is installed in a different directory please enter the full path below</center>\n";
	print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step8\"><input type=\"text\" size=\"50\" name=\"libwww\"></center>\n";
	print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
	print "<p>unless you have installed libwww it probably is not installed on this system\n";
	print "<br>Please see the worldadult.com libwww FAQ for information about installing libwww\n";
	print "<br><a href=\"http://www.worldadult.com/tgsw/faq/libwww.html\">http://www.worldadult.com/tgsw/faq/libwww.html</a>\n";
	}
else
	{
	unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
	print DATA "use LWP\;\n";
	if ($ed)
		{
		$result = eval 'require Net::FTP';
		if ($result) { print DATA "use Net::FTP\;\n"; }
		else
			{
			print "<br>libnet not found, disabling FTP functions.\n";
			print "<p>perl libnet modules are not installed on this server.\n";
			print "<br>The modules are only needed if you want the script to upload files to a different server using FTP.\n";
			print "<br>Information about installing libnet can be found at\n";
			print "<br><a href=\"http://www.worldadult.com/tgsw/re/docs/libnet.html\">http://www.worldadult.com/tgsw/re/docs/libnet.html</a>\n";
			}
		}
	print DATA "\$var=99\;\n";
	close DATA;
	chmod(0666, $setup);
	&step9;
	}

}

sub step8 {

$rd = length($data{libwww}); $rd--;
$last_byte = substr($data{libwww}, $rd, 1);
$first_byte = substr($data{libwww}, 0, 1);
if ($last_byte eq "/") { chop($data{libwww}); }
print "<p>Testing directory <b>$data{libwww}</b> for libwww ... \n<br>\n";
unless (-e "$data{libwww}") { &error("$data{libwww} does not exist"); }
unless (-e "$data{libwww}/LWP.pm") { print ("<LI>$data{libwww}/LWP.pm not found.</LI>\n"); $norp = 1; $libwww=1; }
unless (-e "$data{libwww}/HTTP/Headers.pm") { print ("<LI>$data{libwww}/HTTP/Headers.pm not found.</LI>\n"); $norp = 1; $libwww=1; }
unless (-e "$data{libwww}/LWP/UserAgent.pm") { print ("<LI>$data{libwww}/LWP/UserAgent.pm not found.</LI>\n"); $norp = 1; $libwww=1; }
if ($libwww)
	{
	print "<br><b>Failed</b>\n";
	print "<p>\n<center>Could not find perl libwww modules.</center>\n";
	print "<center>If libwww is installed in a different directory please enter the full path below</center>\n";
	print "<center><form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"step8\"><input type=\"text\" size=\"50\" name=\"libwww\"></center>\n";
	print "<p>\n<center><input type=submit value=\"N E X T\"></form></center>\n";
	print "<p>unless you have installed libwww it probably is not installed on this system\n";
	print "<br>Please see the worldadult.com libwww FAQ for information about installing libwww\n";
	print "<br><a href=\"http://www.worldadult.com/tgsw/faq/libwww.html\">http://www.worldadult.com/tgsw/faq/libwww.html</a>\n";
	exit;
	}
else { print "<br>OK\n"; }

unless (open (DATA, ">>$setup")) { &error("can not open $setup"); }
print DATA "use lib qw($data{libwww})\;\n";
print DATA "\$libinstall=\"$data{libwww}\"\;\n";
print DATA "use LWP\;\n";
if ($ed)
	{
	if (-e "$data{libwww}/Net/FTP.pm") { print DATA "use Net::FTP\;\n"; }
	else
		{
		print "<br>libnet not found, disabling FTP functions.\n";
		print "<p>perl libnet modules are not installed on this server.\n";
		print "<br>The modules are only needed if you want the script to upload files to a different server using FTP.\n";
		print "<br>Information about installing libnet can be found at\n";
		print "<br><a href=\"http://www.worldadult.com/tgsw/re/docs/libnet.html\">http://www.worldadult.com/tgsw/re/docs/libnet.html</a>\n";
		print "<p>If you decide to install libnet, install it into $data{libwww} with libwww.\n";
		}
	}
print DATA "\$var=99\;\n";
close DATA;
chmod(0666, $setup);
&step9;

}

sub step9 {

print "<p>\n<center><b>Finished</b></center>\n";
print "<p>\n<center>Click <a href=\"admin.$fe\">here</a> To start using Thumbnail Gallery Submission Wizard</center>\n";
print "<p>\n<center>The first thing you should do is test your configuration, then click <b>Auto Update</b>.</center>\n";

}

sub error {
print "<BR>Error: \n";
print "$_[0] -- $!";
print "\n";
exit;
}

sub htt_top {

$| = 1;
print "<HTML><HEAD><TITLE>Thumbnail Gallery Submission Wizard SETUP</TITLE></HEAD><BODY>\n";
print ("<FONT FACE=\"Comic Sans MS\"><FONT SIZE=+3><B><center>THUMBNAIL");
print (" GALLERY<br>SUBMISSION WIZARD</CENTER></B></FONT></FONT>\n");

}

sub config {

@nolist = ('your_name','your_email','mailprog','path_cgi','source_dir','subd','thumb','dest_dir','base_url','num_to_show','var');
print ("<p>\n<center><FONT SIZE=+1><b>Advanced Options Configuration</b></FONT></center>\n");
$setupm="$path_cgi/setup.pl";
if (-e $setup)
	{
	unless (open (DATA, "$setup"))
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "Failed to open $setup\n";
		print "<p>\nServer said <b>$!</b>\n";
		print "</td></tr></table>\n";
		}
	}
@files = <DATA>;
print "<form method=\"post\"><input type=\"hidden\" name=\"action\" value=\"configup\">\n";
print "<table align=\"center\" border=\"7\">\n";
foreach $line(@files) {

if ($line =~ "=")
	{
	#good print "<tr><td>";
	print "<tr>";
	($name, $value) = split(/=/, $line);
	@namea = split(/ /, $name);
	if (($namea[0] =~ "#") && ($namea[0] ne "#")) { @namez = split(/#/, $namea[0]); $namea[1]=$namez[1]; }
	@valua = split(/"/, $value);
	if (($valua[0]) && ($valua[0] ne " ")) { $value = $valua[0]; }
	else { $value = $valua[1]; }
	for ($value) {
		s/^\s+//;
		s/\s+$//;
	}
	$rd = length($value); $rd--;
	$last_byte = substr($value, $rd, 1);
	if ($last_byte eq ";") { chop($value); }
	if ($namea[0] =~ "#")
		{
		$noprint=0;
		foreach $dud(@nolist)
			{
			if ($namea[1] =~ $dud) { $noprint=1; }
			}
		$rd = length($namea[1]); $rd--;
		$byte = substr($namea[1], 1, $rd);
		unless ($noprint) { print "<td><select name=\"$namea[1]com\"><option selected>DISABLED<option>ENABLED</select>\n"; }
		else { print "<td>"; }
		print "</td><td><a href=\"http://www.worldadult.com/tgsw/option.html#$byte\" target=\"_new\">$byte</a></td>\n<td><input type=\"";
		if ($value eq "1") { print "hidden\""; }
		else { print "text\" size=\"50\""; }
		print " name=\"$namea[1]\" value=\"$value\"></td></tr>\n";
		}
	else
		{
		$noprint=0;
		foreach $dud(@nolist)
			{
			if ($namea[0] =~ $dud) { $noprint=1; }
			}
		$rd = length($namea[0]); $rd--;
		$byte = substr($namea[0], 1, $rd);
		unless ($noprint) { print "<td bgcolor=\"#00FF00\"><select name=\"$namea[0]com\"><option selected>ENABLED<option>DISABLED</select>\n"; }
		else { print "<td>"; }
		print "</td><td><a href=\"http://www.worldadult.com/tgsw/option.html#$byte\" target=\"_new\">$byte</a></td>\n<td><input type=\"";
		if ($value eq "1") { print "hidden\""; }
		else { print "text\" size=\"50\""; }
		print " name=\"$namea[0]\" value=\"$value\"></td></tr>\n";
		}
	}

}

print "</table>\n<p>\n<center><input type=\"submit\" value=\"save changes\"></center>\n";
print "<p>\n<center><a href=\"http://www.worldadult.com/tgsw/option.html#custom\" target=\"_new\">Custom Options</a></center>\n";
print "<center><TEXTAREA name=custom rows=4 cols=60 wrap=\"off\"></TEXTAREA></center>\n";
print "<p>\n</form>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#CCCCCC\"><tr><td>\n";
print "<p>\nClick on option name for description of function. \n";
print "<br>Be advised changes made will be accepted which may render TGSW unusable. \n";
print "<br>Only make changes if you understand what you are doing. \n";
print "<p>\n<b>Configuration Wizard</b> is the recommended method of configuration. \n";
print "<p>\n</td></tr></table>\n";

}

sub configup {

if (-e $setup)
	{
	unless (open (DATA, "$setup"))
		{
		print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
		print "Failed to open $setup\n";
		print "<p>\nServer said <b>$!</b>\n";
		print "</td></tr></table>\n";
		}
	}
@files = <DATA>;
@pairs = split(/&/, $buffer);
$formdata=~s/\s+$//;
foreach (split(/&/, $formdata)) {
	($name, $value)=split(/=/, $_);
	$name=~s/\+/ /g;
	$name=~s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
	$value=~s/\+/ /g;
	$value=~s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
	$data{$name}=$value;
	$diname="$name"."com";
	if ($name eq "action") { next; }
	$rd = length($name); $rd--;
	$byte = substr($name, 1, $rd);
	$bytea = $byte."=";
	$byteb = $byte." =";
	foreach $line (@files)
		{
		if (($line =~ $bytea) || ($line =~ $byteb))
			{
			$full="";
			if ($data{$diname} =~ "DIS") { $full .= "# "; }
			$full .= "$name=";
			if ($line =~ "\"") { $full .= "\""; }
			$full .= "$value";
			if ($line =~ "\"") { $full .= "\""; }
			$full .= "\;\n";
			$line=join("\t", $full);
			}
		}
}

unless (open (DATA, ">$setup"))
	{
	print "<p>\n<table align=\"center\" border=\"4\" BGCOLOR=\"#FF0000\"><tr><td>\n";
	print "Can not write to $setup\n";
	print "<p>\nServer said <b>$!</b>\n";
	print "</td></tr></table>\n";
	}

print DATA @files;
if ($data{'custom'}) { print DATA "$data{'custom'}"; print DATA "\n"; }
close DATA;
chmod(0666, $setup);

&config;

}

sub red {

$rd = length($data{path}); $rd--;
$last_byte = substr($data{path}, $rd, 1);
$first_byte = substr($data{path}, 0, 1);
if ($last_byte eq "/") { chop($data{path}); }
print "<p>\n<center><a href=\"setup.$fe";
print "?$data{path}\">NEXT</a></center>\n";

}
